<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px">
			<el-form-item label="区域名称" prop="region_name">
				<el-input v-model="form.region_name" placeholder="请输入区域位置" clearable></el-input>
			</el-form-item>
			<el-form-item label="机房代码" prop="room_code">
				<el-input v-model="form.room_code" placeholder="请输入机房代码" clearable></el-input>
			</el-form-item>
			<el-form-item label="机房全称" prop="room_name">
				<el-input v-model="form.room_name" placeholder="请输入机房名称" clearable></el-input>
			</el-form-item>
			<el-form-item label="机房位置" prop="room_location">
				<el-input v-model="form.room_location" placeholder="请输入机房位置" clearable></el-input>
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSave" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	name: "addRegion",
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增',
				edit: '编辑',
				show: '查看'
			},
			setMap:{
				regionList:[]
			},
			visible: false,
			isSave: false,
			//表单数据
			form: {
				id:"",
				region_name: "",
				room_code:"",
				room_name: "",
				room_location: ""
			},
			//验证规则
			rules: {
				region_name: [
					{required: true, message: '请输入区域位置'}
				],
				room_code: [
					{required: true, message: '请输入机房代码'}
				],
				room_name: [
					{required: true, message: '请输入机房名称'}
				],
				room_location: [
					{required: true, message: '请输入机房位置'}
				],
			},
		}
	},
	mounted() {

	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},

		async getRoom() {
			const res = await this.$API.setup.regional.regionalList.post();
			if (res.code == 200) {
				this.setMap.regionList = res.data;
			}
		},

		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSave = true;
					const res = await this.$API.setup.regional.add.post(this.form);
					this.isSave = false;
					if(res.code == 200){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}
				}
			})
		},
		setData(data){
			Object.assign(this.form, data);
		}
	}
}
</script>

<style scoped>

</style>
